xref: /freebsd/tools/boot/ci-qemu-test.sh (revision 7cc42f6d)
1#!/bin/sh
2
3# Install pkgbase packages for loader, kernel, and enough of userland to boot
4# in QEMU and echo "Hello world." from init, as a very quick smoke test for CI.
5# Uses QEMU's virtual FAT filesystem to avoid the need to create a disk image.
6# While designed for CI automated testing, this script can also be run by hand
7# as a quick smoke-test as long as pkgbase packages have been built.  The
8# rootgen.sh and related scripts generate much more extensive tests for many
9# combinations of boot env (ufs, zfs, geli, etc).
10#
11# $FreeBSD$
12
13set -e
14
15die()
16{
17	echo "$*" 1>&2
18	exit 1
19}
20
21tempdir_cleanup()
22{
23	trap - EXIT SIGINT SIGHUP SIGTERM SIGQUIT
24	rm -rf ${ROOTDIR}
25}
26
27tempdir_setup()
28{
29	# Create minimal directory structure and populate it.
30
31	for dir in dev bin efi/boot etc lib libexec sbin usr/lib usr/libexec; do
32		mkdir -p ${ROOTDIR}/${dir}
33	done
34
35	# Install kernel, loader and minimal userland.
36	cat<<EOF >${ROOTDIR}/pkg.conf
37REPOS_DIR=[]
38repositories={local {url = file://$(dirname $OBJTOP)/repo/\${ABI}/latest}}
39EOF
40	ASSUME_ALWAYS_YES=true INSTALL_AS_USER=true pkg \
41	    -o ABI_FILE=$OBJTOP/bin/sh/sh \
42	    -C ${ROOTDIR}/pkg.conf -r ${ROOTDIR} install \
43	    FreeBSD-kernel-generic FreeBSD-bootloader \
44	    FreeBSD-clibs FreeBSD-runtime
45
46	# Put loader in standard EFI location.
47	mv ${ROOTDIR}/boot/loader.efi ${ROOTDIR}/efi/boot/BOOTx64.EFI
48
49	# Configuration files.
50	cat > ${ROOTDIR}/boot/loader.conf <<EOF
51vfs.root.mountfrom="msdosfs:/dev/ada0s1"
52autoboot_delay=-1
53boot_verbose=YES
54EOF
55	cat > ${ROOTDIR}/etc/rc <<EOF
56#!/bin/sh
57
58echo "Hello world."
59/sbin/sysctl vm.stats.vm.v_wire_count
60/sbin/shutdown -p now
61EOF
62
63	# Entropy needed to boot, see r346250 and followup commits/discussion.
64	dd if=/dev/random of=${ROOTDIR}/boot/entropy bs=4k count=1
65
66	# Remove unnecessary files to keep FAT filesystem size down.
67	rm -rf ${ROOTDIR}/METALOG ${ROOTDIR}/usr/lib
68}
69
70# Locate the top of the source tree, to run make install from.
71: ${SRCTOP:=$(make -V SRCTOP)}
72if [ -z "${SRCTOP}" ]; then
73	die "Cannot locate top of source tree"
74fi
75: ${OBJTOP:=$(make -V OBJTOP)}
76if [ -z "${OBJTOP}" ]; then
77	die "Cannot locate top of object tree"
78fi
79
80# Locate the uefi firmware file used by qemu.
81: ${OVMF:=/usr/local/share/uefi-edk2-qemu/QEMU_UEFI_CODE-x86_64.fd}
82if [ ! -r "${OVMF}" ]; then
83	echo "NOTE: UEFI firmware available in the uefi-edk2-qemu-x86_64 package" >&2
84	die "Cannot read UEFI firmware file ${OVMF}"
85fi
86
87# Create a temp dir to hold the boot image.
88ROOTDIR=$(mktemp -d -t ci-qemu-test-fat-root)
89trap tempdir_cleanup EXIT SIGINT SIGHUP SIGTERM SIGQUIT
90
91# Populate the boot image in a temp dir.
92( cd ${SRCTOP} && tempdir_setup )
93
94# And, boot in QEMU.
95: ${BOOTLOG:=${TMPDIR:-/tmp}/ci-qemu-test-boot.log}
96timeout 300 \
97    qemu-system-x86_64 -m 256M -nodefaults \
98   	-drive if=pflash,format=raw,readonly,file=${OVMF} \
99        -serial stdio -vga none -nographic -monitor none \
100        -snapshot -hda fat:${ROOTDIR} 2>&1 | tee ${BOOTLOG}
101
102# Check whether we succesfully booted...
103if grep -q 'Hello world.' ${BOOTLOG}; then
104	echo "OK"
105else
106	die "Did not boot successfully, see ${BOOTLOG}"
107fi
108